;------------------------------------------------------------------
;ploting rectangle
;------------------------------------------------------------------
PRO rectangle,xx,yy,sirka,vyska ;nakresli obdelnik
device,set_graphics=6
px=[xx,xx+sirka,xx+sirka,xx,xx]
py=[yy,yy,yy+vyska,yy+vyska,yy]
plots,px,py,/dev,thick=2,lines=0,color=!D.N_colors-1
empty
END
;-----------------------------------------------------------------
;handling the screens and opening .fit file, and showing the
;thumbnail of the image in the other screen
;-----------------------------------------------------------------
pro OpenFile, Event
common share1,a,rozmer,okno1,okno2,okno3

winhis=widget_info(Event.top,find_by_uname='WID_DRAW_0')
widget_control,winhis,get_value=okno2
uoroi=widget_info(Event.top,find_by_uname='WID_DRAW_1')
widget_control,uoroi,get_value=okno3
im=widget_info(Event.top,find_by_uname='WID_DRAW_2')
widget_control,im,get_value=okno1

filer=''
r=filer+pickfile(/MUST_EXIST,TITLE=' Pick a Calibrated Profile',FILTER='*.fit', $
               GET_PATH=pathk,    /READ)

a = readfits(r,header)
rozmer=size(a)
wset, okno1
tv,a
;.........................................
;there is a problem in dealing with errors - for instance
;there is no way keep the program stabile if you
;open the folder with the data and click 'cancel'
;.........................................
b=congrid(a,320,128,/interp)
wset,okno3
tv,b
;....................
;I didn't have the time to test some ideas about
;ploting underexposed and overexposed pixels in
;thumbnail window, but will keep working on it
;....................

;----------------------------------------
;reading the time of exposition, date, time, line and type of data from the filename,
;and puting them in label widgets
;----------------------------------------

first=strpos(r,'s_voss')
extime=' '
extime=strmid(r,first+32,3)
extimeID=widget_info(Event.top,find_by_uname='WID_LABEL_12')
widget_control,extimeID,set_value=extime+'ms'

day=strmid(r,first+7,2)
month=strmid(r,first+10,2)
year=strmid(r,first+13,2)
dateID=widget_info(Event.top,find_by_uname='WID_LABEL_14')
widget_control,dateID,set_value=day+'.'+month+'.'+year+'.'

hour=strmid(r,first+16,2)
minute=strmid(r,first+19,2)
sec=strmid(r,first+22,4)
tmID=widget_info(Event.top,find_by_uname='WID_LABEL_16')
widget_control,tmID,set_value=hour+':'+minute+':'+sec

linija=strmid(r,first+27,2)
lineID=widget_info(Event.top,find_by_uname='WID_LABEL_18')
widget_control,lineID,set_value=linija

tip=strmid(r,first+30,1)
typeID=widget_info(Event.top,find_by_uname='WID_LABEL_20')
widget_control,typeID,set_value=tip

end
;-----------------------------------------------------------------
;finding mean value of intensity of pixels of ROI (Region Of Interest)
;and ploting histogram of ROI
;-----------------------------------------------------------------
pro Result, Event

common share1,a,rozmer,okno1,okno2,okno3
common share2,x,y
common share3,widroi,heiroi
common share4,v

wset,okno1
;....................
;there is A BIG problem with drawing rectangles, it MUST be solved!!!
;....................
rectangle,event.x,event.y,widroi,heiroi

Label3=widget_info(Event.top,find_by_uname='WID_LABEL_10')
v=a[x:x+widroi-1,y:y+heiroi-1]

dimv=size(v)

meanint=total(v)/(widroi*heiroi)
widget_control,Label3,set_value=string(meanint)


hiss=histogram(v, BINSIZE=1.0)
bins = FINDGEN(N_ELEMENTS(hiss)) + MIN(v)

wset,okno2
PLOT, bins, hiss, YRANGE = [MIN(hiss)-1, MAX(hiss)+1], PSYM = 10, $
XTITLE = 'Intensity', YTITLE = 'Number of pixels', color=get_color('yellow')
end

pro Destroy1, Event
;......................
;I don't know if this do anything, it was my try to deal with
;errors, but I don't think it worked
;......................
wset, okno1 & erase
tv,a
end
;----------------------------------------------------------
;printing position and intensity of the individual pixels
;(on moving cursor) and drawing rectangle ROI
;----------------------------------------------------------
pro GetValue, Event

common share1,a,rozmer,okno1,okno2,okno3
common share2,x,y
common share3,widroi,heiroi
common share4,v

Label1=widget_info(Event.top,find_by_uname='WID_LABEL_7')
widget_control, Label1, set_value=strcompress('('+string(event.x)+','+string(event.y)+')')

Label2=widget_info(Event.top,find_by_uname='WID_LABEL_9')
widget_control,Label2,set_value=string(a(event.x,event.y))

Label4=widget_info(Event.top,find_by_uname='WID_SLIDER_0')
widget_control,Label4,get_value=widroi

Label5=widget_info(Event.top, find_by_uname='WID_SLIDER_1')
widget_control,Label5, get_value=heiroi


x=event.x
y=event.y

end
;-----------------------------------------------------------------
;exit from the program
;-----------------------------------------------------------------
pro OnExit, Event
widget_control,event.top,/destroy
end
;
; Empty stub procedure used for autoloading.
;
pro guiv4_eventcb
end
;-----------------------------------------------------------------


;-----------------------------------------------------------------
;......................
;this desn't do a thing, but I cannot remove it for some reason
;......................
pro Histogram, Event

end
;
; Empty stub procedure used for autoloading.
;
pro exposice_eventcb
end
